/* 
 * prof. Constantin Galatan
 * O(n*m)
 */
#include <string>
#include <cstring>
#include <fstream>
#include <algorithm>
#include <queue>
using namespace std;

const int Inf = 0x3f3f3f3f;
int n, m, K;
string a, b, s;
int E1[91][91], E2[91][91];
int p1[256], p2[256]; // p1[s[k]] = poz pe care sta s[k] in sirul a

struct State {
  int i, j, k;
};

queue<State> q;
int main()
{
    ifstream fin("birot.in");
    ofstream fout("birot.out");

	getline(fin, a);
	getline(fin, b);
	getline(fin, s);

	n = a.size(); m = b.size(); K = s.size();
	for (int i = 0; i < n; ++i)
		p1[(int)a[i]] = i;

	for (int i = 0; i < m; ++i)
		p2[(int)b[i]] = i;

    memset(E1, 0x3f, sizeof(E1));

	int x, y, e1, e2, i, j, p;
	x = p1[(int)s[0]];	y = p2[(int)s[0]];
	e1 = min(x, n - x);	e2 = min(y, m - y);
    E1[x][0] = e1; E1[0][y] = e2;

    q.push({x, 0, 0}); q.push({0, y, 0});
    for (int k = 1; k < K; ++k, memcpy(E1, E2, sizeof(E2)))
    {
		memset(E2, 0x3f, sizeof(E2));
        while ( !q.empty() )
        {
            i = q.front().i, j = q.front().j, p = q.front().k;
            if ( p == k )
                break;
            q.pop();
            x = p1[(int)s[k]]; y = p2[(int)s[k]];
            e1 = min(abs(x - i), n - abs(x - i));
            e2 = min(abs(y - j), m - abs(y - j));

            if ( e1 + E1[i][j] < E2[x][j] )
            {
                q.push({x, j, k});
                E2[x][j] = e1 + E1[i][j];
            }
            if ( e2 + E1[i][j] < E2[i][y] )
            {
                q.push({i, y, k});
                E2[i][y] = e2 + E1[i][j];
            }
		}
	}

	int ans = Inf;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			ans = min(ans, E1[i][j]);
	fout << ans << '\n';

	fin.close();
	fout.close();
}
