/* prof. Constantin Galatan
 * O(n*m*m)
 */
#include <string>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>

using namespace std;

ifstream fin("birot.in");
ofstream fout("birot.out");

const int Inf = 0x3f3f3f3f;
int n, m, K;
string a, b, s;
int E[2][91][91];
int p1[256], p2[256]; // p1[s[k]] = poz pe care sta s[k] in sirul a

int main()
{
	getline(fin, a);
	getline(fin, b);
	getline(fin, s);

	n = a.size(); m = b.size(); K = s.size();
	for (int i = 0; i < n; ++i)
		p1[(int)a[i]] = i;

	for (int i = 0; i < m; ++i)
		p2[(int)b[i]] = i;

	memset(E, 0x3f, sizeof(E));

	int x, y, e1, e2;
	x = p1[(int)s[0]];	y = p2[(int)s[0]];
	e1 = min(x, n - x);	e2 = min(y, m - y);

	E[0][x][0] = e1; E[0][0][y] = e2;
	int c = 1, p = 0;
	for (int k = 1; k < K; ++k, c = !c, p = !p)
	{
		memset(E[c], 0x3f, sizeof(E[c]));
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
			{
				if ( E[p][i][j] == Inf ) continue;
				x = p1[(int)s[k]]; y = p2[(int)s[k]];
				e1 = min(abs(x - i), n - abs(x - i));
				e2 = min(abs(y - j), m - abs(y - j));

				E[c][x][j] = min(E[c][x][j], e1 + E[p][i][j]);
				E[c][i][y] = min(E[c][i][y], e2 + E[p][i][j]);
			}
	}

	int ans = Inf;

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			ans = min(ans, E[p][i][j]);
	fout << ans << '\n';

	fin.close();
	fout.close();
}
