/*
    prof. Constantin Galatan
    Solutie greedy
    Complexitate: O(n * log n)
*/
#include <cstdio>
#include <vector>
#include <algorithm>

struct El {
	int v, i;
};

using VE = std::vector<El>;
using VI = std::vector<int>;
using VB = std::vector<bool>;

const int Inf = 0x3f3f3f3f;
int n, Lmax;
VB got;
VE e;
VI a, b, c, v;

int LIS(const VI& b);
void get(int &x);

int main()
{
	freopen("torturi.in", "r", stdin);
	freopen("torturi.out", "w", stdout);
	get(n);
	a = v = VI(n + 1); // v poate n + 1
	got = VB(n); e = VE(n);

	for (int i(0), x(0); i < n; ++i)
	{
		get(x);
		e[i].v = a[i] = x;
		e[i].i = i;
	}

	std::sort( e.begin(), e.end(),
		       [](const El& a, const El& b)
			   { return a.v > b.v || (a.v == b.v && a.i < b.i); }
		     );

	for (int j(0), i(0), lasti(-1); j < n; ++j)
	{
		i = e[j].i;
		if ( i < lasti ) continue;
		got[i] = true;
		c.push_back(a[i]);
		lasti = i;
	}

	for (int i = 0; i < n; ++i)
		if ( !got[i] )
			b.push_back(a[i]);

	printf("%d\n", LIS(b) + static_cast<int>(c.size()));
}

inline int Bs(int x)
{
    if (v[Lmax] >= x) return Lmax + 1;

    int l(1), r(Lmax), p(0), m;
    while (l <= r )
    {
        m = (l + r) / 2;
        if (v[m] >= x)
        	l = m + 1;
		else
			r = m - 1, p = m;
    }
    return p;
}

int LIS(const VI& b)
{
	int p(0); v[0] = Inf;
    for (const int& x : b)
    {
		p = Bs(x);
        if (p > Lmax)
			Lmax++, p = Lmax;
        v[p] = x;
    }
	return Lmax;
}

const int Lim = 100000;
int p =  Lim - 1;
char s[Lim];

void Next()
{
    if (++p == Lim)
        std::fread(s, 1, Lim, stdin), p = 0;
}

void get(int &x)
{
    for (; s[p] < '0' || s[p] > '9'; Next());
    for (x = 0; s[p] >= '0' && s[p] <= '9'; Next())
        x = x * 10 + s[p] - '0';
}
